
import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.*;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;



/**
 *  KostenRisiko Ein Applet zur einfachen Abschtzung der Kosten eines
 *  Zivilprozesses
 *  Version 3.2 16.11.04 - Mit Kostenquote und Einigung, Hchststreitw. 30 Mio
 *  Version 3.1 - Fehler bei pausch. Auslagen beseitigt
 *  Version 3.2 - erweitert um Einigung
 *  Version 3.3 - USt. 19%
 *  freeware GNU GPL
 *@author     Franz Xaver Dimbeck, Erding
 *@created    7. Januar 2007
 */
public class KostenRisiko extends java.applet.Applet 
{
    private java.lang.String farbe;
    private int a;
    private Color       cFarbe;
    private Label       lStreitwert;
    private TextField   eStreitwert;
    private Checkbox    KlgAnw;
    private Checkbox    BklAnw;
    private Label       lAuslagen;
    private Button      bHilfe;
    private TextField   eAuslagen;
    private	Label       lErgebnis;
    private TextField   eErgebnis;
    private TextArea    tTEXT;
    private Checkbox    chBerufung;
    private Checkbox    chEinigung;
    private Font        myFont;
    private Font        ergFont;
    private Font        helpFont;
    /**
    *  Constructor fr das KostenRisiko object
    */
    public void KostenRisiko() 
    {
    }
    
public static void main( String args[] )
   {
   final KostenRisiko applet = new KostenRisiko();
   Frame frame = new Frame( "Kostenrisiko" );
   frame.setSize( 300, 450 + 26 /* allow room for Frame bar */ );
   frame.addWindowListener
   (
   new WindowAdapter()
      {
      public void windowClosing( WindowEvent e )
         {
         applet.stop();
         applet.destroy();
         System.exit( 0 );
         } // end WindowClosing
      } // end anonymous class
   ); // end addWindowListener line
   frame.add( applet ); 
  
   frame.setVisible( true );  
   applet.init();
   applet.start();
   frame.validate();

   }       // end main
   
   

	/**
	 *  Initialisierung des Applets
	 */
	public void init() {
		super.init();
		
		myFont = new Font("Helvetica", Font.BOLD, 12);
		ergFont = new Font("Monospaced", 0, 12);
		helpFont = new Font("Helvetica", 0, 11);

	java.awt.Panel  panel  = new Panel();
	panel.setLayout(new GridLayout(5, 2,4,4));

		lStreitwert = new Label("Streitwert");
		lStreitwert.setFont(myFont);
		panel.add(lStreitwert);

		eStreitwert = new TextField();
		panel.add(eStreitwert);
// VER 3.2
		lErgebnis = new Label("Ergebnis");
		lErgebnis.setFont(myFont);
		panel.add(lErgebnis);

		eErgebnis = new TextField();
		panel.add(eErgebnis);
//

		lAuslagen = new Label("Beweisauslagen");
		lAuslagen.setFont(myFont);
		panel.add(lAuslagen);
		eAuslagen = new TextField();
		panel.add(eAuslagen);

		tTEXT = new TextArea("", 12, 36, TextArea.SCROLLBARS_VERTICAL_ONLY);
		tTEXT.setFont(ergFont);
		tTEXT.setBackground(new Color((new Integer(a)).parseInt("FFF8d8", 16)));
		tTEXT.setForeground(java.awt.Color.blue);

		tTEXT.setEditable(false);
		panel.add(tTEXT);
			
		KlgAnw = new Checkbox("Kl\344ger hat Anwalt");
		KlgAnw.setFont(myFont);
		panel.add(KlgAnw);

		BklAnw = new Checkbox("Beklagter hat Anwalt");
		BklAnw.setFont(myFont);
		panel.add(BklAnw);
		chEinigung = new Checkbox("Einigung");
		chEinigung.setFont(myFont);
		panel.add(chEinigung);
		chBerufung = new Checkbox("Berufung");
		chBerufung.setFont(myFont);
		panel.add(chBerufung);

		bHilfe = new Button("Hilfe");
                                        
	//	panel.add(bHilfe);
                                        //damit die Auslagen in ne neue Zeile kommen


		setLayout(new BorderLayout(4,4));
		add("North", panel);

		add("South", bHilfe);
		add("Center", tTEXT);

                                  // Applet PARAMS Farbe abfragen
		try {
			farbe = getParameter("Farbe");
			cFarbe = new Color((new Integer(a)).parseInt(farbe, 16));
		} catch (java.lang.RuntimeException runtimeexception) {
			//cFarbe = java.awt.Color.white;
			cFarbe=java.awt.SystemColor.control;
		}

		setBackground(cFarbe);
		panel.setBackground(cFarbe);
		KlgAnw.setBackground(cFarbe);
		BklAnw.setBackground(cFarbe);
		lStreitwert.setBackground(cFarbe);
		lAuslagen.setBackground(cFarbe);


	// VER 3.2
		lErgebnis.setBackground(cFarbe);
		chEinigung.setBackground(cFarbe);
		
	//
		chBerufung.setBackground(cFarbe);

		a = cFarbe.getRed() + cFarbe.getGreen() + cFarbe.getBlue();
		if (a < 500) {
			setForeground(java.awt.Color.white);
			KlgAnw.setForeground(java.awt.Color.white);
			BklAnw.setForeground(java.awt.Color.white);
			lStreitwert.setForeground(java.awt.Color.white);
			lAuslagen.setForeground(java.awt.Color.white);
			chBerufung.setForeground(java.awt.Color.white);
			chEinigung.setForeground(java.awt.Color.white);
			lErgebnis.setForeground(java.awt.Color.white);
		}
		rechne();
	}

	/**
	 *  Behandlung der Benutzerinteraktionen
	 *
	 *@param  event  Benutzerinteraktion
	 *@return        true bei definerten Aktionen
	 */
	public boolean handleEvent(java.awt.Event event) {
		if ((event.id == 1001) && (event.target == chBerufung)) {
			if (chBerufung.getState()) {
				KlgAnw.setState(true);
				BklAnw.setState(true);
			}
			rechne();
			return true;
		}
		if ((event.id == 402) && (event.target == eAuslagen)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == KlgAnw)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == BklAnw)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == chEinigung)) {
			rechne();
			return true;
		}
		if ((event.id == 402) && (event.target == eStreitwert)) {
			rechne();
			return true;
		}
		if ((event.id == 402) && (event.target == eErgebnis)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == bHilfe)) {
		java.lang.String  hText;
			tTEXT.setFont(helpFont);
			tTEXT.setBackground(new Color((new Integer(a)).parseInt("FFF8d8", 16)));
			tTEXT.setForeground(java.awt.Color.blue);

			hText =	"\tKosten eines Zivilprozesses"
				 + "\n\tKostenRisiko Version 3.3 (USt 19%)"
				 + "\nCopyright \251 1998-2007 Franz Xaver Dimbeck, Erding"
				 + "\n\tFreeware Lizenz GNU GPL"
				 + "\n\thttp://jurfree.dimbeck.de"
				 + "\nFehlermeldungen, Verbesserungsvorschlge, Danksagungen etc. an:"
				 + " jurfree@dimbeck.de"
                 + "\n__________________________________________"
				 + "\nBerechnet wird das Kostenrisiko eines Standardfalles. "
				 + "Die Kosten knnen sich erhhen, z.B. durch Reisekosten "
				 + "des Anwalts, durch Hinzuziehung weiterer Anwlte, "
				 + "durch mehr als einen Auftraggeber auf der Klger- "
				 + "oder Beklagtenseite, durch vorgerichtliche Ttigkeiten usw."
				 + "\n\n"
				 + "Eingaben"
                 + "\n\n\t'Streitwert':"
                 + "\nDer Wert des Gegenstandes, um den prozessiert wird. "
                 + "Bitte in Euro eingeben, ggf. mit Dezimalkomma."
                 + "\n\n\t'Ergebnis':"
                 + "\nGeben Sie hier den Betrag ein, den Sie als Ergebnis "
                 + "erwarten, also etwa den beabsichtigten Vergleichsbetrag."
                 + "\nDas Programm errechnet dann auch die Kostenquote und "
                 + "die Betrge, die auf Klger und Beklagten entfallen."
                 + "\nWenn Sie hier nichts oder 0 eingeben, werden die "
                 + "Kosten berechnet, die beim vollstndigen Unterliegen "
                 + "des Klgers entstehen."
                 + "\n\n\t'Beweisauslagen':"
                 + "\nGeben Sie hier die zustzlichen Kosten einer etwaigen "
                 + "Beweisaufnahme ein, z.B. Zeugenentschdigungen, "
                 + "Sachverstndigenkosten."
                 + "\n\n\t'Klger hat Anwalt':"
				 + "\n\t'Beklagter hat Anwalt':"
				 + "\nMarkieren Sie hier bitte, ob bei der Kostenberechnung "
				 + "kein Anwalt, ein Anwalt oder zwei Anwlte bercksichtigt "
				 + "werden sollen."
                 + "\n\n\t'Einigung':"
                 + "\nWenn Sie dieses Feld markieren, werden die Kosten "
                 + "berechnet die bei einer Einigung (Vergleich) entstehen. "
                 + "Die Anwaltskosten werden um  die Einigungsgebhr erhht "
                 + "und bei den Gerichtskosten wird die ermigte Gebhr "
                 + "angesetzt.\n"
                 + "Wenn dasFeld nicht markiert ist, werden die Kosten "
                 + "berechnet, die bei einem streitigen Urteil entstehen."
                 + "\n\n\t'Berufung':"
                 + "\nWenn dieses Feld markiert ist, werden die Kosten eines "
                 + "Berufungsverfahrens berechnet.\n"
                 + "__________________________________________\n"
    ;
			tTEXT.setText(hText);
			return true;
		} else {
			return super.handleEvent(event);
		}
	}

	/**
	 *  wertet die Benutzereingaben aus und berechnet die Kosten
	 */
	public void rechne() {
	double            dZhtAnw   = 0.0D;        //  Zehntel Anwalt
	double            dZhtGer   = 0.0D;        //  Zehntel Gericht
	
	double            d     = 0.0D;        //  Anwaltsgebhr
	double            dNumAnw    = 0.0D;        //  Anzahl der Anwlte
	double            dGergeb    = 0.0D;        //  Gerichtsgebhr
	double            dAusl    = 0.0D;        //  Auslagen
	double            dPausch    = 0.0D;        //  Auslagenpauschale
	double            dMwst    = 0.0D;        //  Mehrwertsteuer
	double            strw;                //  Streitwert
	double            dErg;                //  Prozessergebnis
	double            dGestamtkosten;                //  Gestamtkosten
	
	long            dQuoteK;              //  Quote Obsigen Klger
	long            dQuoteB;              //  Quote Obsigen Beklagter

	java.lang.String  s;                   //  fr Textausgabe

		tTEXT.setFont(ergFont);
		tTEXT.setBackground(java.awt.Color.white);
		tTEXT.setForeground(java.awt.Color.black);
		
		strw = KostenRisiko.getDouble(eStreitwert);
		dErg = KostenRisiko.getDouble(eErgebnis);
		
// Fehlermeldugen
		if (strw < 0.01D) {
			s = "Bitte Streitwert in Euro eingeben.\n\n"
			    +"Hinweise zur Eingabe erhalten Sie, "
			    +"wenn sie unten auf die Schaltflche "
			    +"'Hilfe' klicken.\n"
			    +"Der Hilfetext verschwindet wieder, wenn Sie wieder "
			    +"Eingaben machen.\n";
			
			tTEXT.setText(s);
			return;
		}
		
		if (strw > 30000000D) {
			s="Streitwert hchstens 30 Millionen\n  22 Abs. 2 RVG,  39 Abs. 2 GKG.\n";
			s+="\nGeben Sie bitte einen geringeren Streitwert ein.\n";
			tTEXT.setText(s);
			return;
		}
			

		
		if (dErg >strw) {
			s = "Ergebnis darf nicht grer als Streitwert sein\n";
			tTEXT.setText(s);
			return;
		}
//
		
// ------------------------------
//          Berechnung
// ------------------------------
		double dtep;
		dtep=100D*runde(dErg/strw);
		dQuoteK = (long)  dtep;
		dQuoteB=100-dQuoteK;


		if (KlgAnw.getState()) {
			dNumAnw = 1.0D;
		}
		if (BklAnw.getState()) {
			dNumAnw++;
		}

		

		dZhtAnw = 25  ;                  //Zehntel ohne Einigung 1.Insantz
        dZhtGer =30;                                
		if (chBerufung.getState()) {
			dZhtAnw = 28  ;   
			dZhtGer=40;
		}
 		if (chEinigung.getState()) {
			dZhtAnw = 35  ;   
			dZhtGer=10;
			if (chBerufung.getState()) {
			dZhtAnw = 41  ;   
			dZhtGer=20;
				
            };
        };
        dZhtAnw *= dNumAnw  ;                  

		d = GebRVG(strw, dZhtAnw);
		dGergeb = GebGkgE(strw, dZhtGer);

		dAusl = KostenRisiko.getDouble(eAuslagen);

		if (dNumAnw > 0.0D) {                      //Auslagenpauschale berechnen
			dPausch = (d * 0.2D) / dNumAnw;				 // 20%
			if (dPausch > 20D) {                      // hchstens 20 EURO
				dPausch = 20D;
			}
			dPausch *= dNumAnw;                            // gesamte Anwaltsgebhren
			dMwst = (d + dPausch) * 0.19D;
		} else {
			d = 0;
		}
		dGestamtkosten=d + dGergeb + dPausch + dMwst + dAusl;
// ------------------------------
//          Textergebnis
// ------------------------------
		s = "";
		if (chBerufung.getState()) {
			s += "2";
		} else {
			s += "1";
		}
		s += ". Instanz, ";
		if (dNumAnw == 0) {
			s += "ohne Anwlte";
		} else if (dNumAnw == 1) {
			s += "ein Anwalt";
		} else {
			s += "zwei Anwlte";
		}
		if (chEinigung.getState())
			s += ", Einigung\n";
		else
			s += ", Urteil\n";
			
		s += "Streitwert   " + KostenRisiko.dbl2str(strw) + "\n";
		s+= "Ergebnis     " + KostenRisiko.dbl2str(dErg) + "\n";
		s+="Kostenquoten: Klg. " + dQuoteB + "%  Bkl. "+ dQuoteK +"%\n";
	    s += "Kosten Klg.  "+ dbl2str(dQuoteB*(dGestamtkosten)/100)+"\n";
	    s += "Kosten Bkl.  "+ dbl2str(dQuoteK*(dGestamtkosten)/100)+"\n";
	    s += "Ergebnis Klg."+ dbl2str(dErg-dQuoteB*(dGestamtkosten)/100)+"\n";
	    s += "Ergebnis Bkl."+ dbl2str(-dErg-dQuoteK*(dGestamtkosten)/100)+"\n";
				
		s += "____________________________________\n";
		s += "\tKostenberechnung\n";
		if (dNumAnw >0D) {
			s = s + "Anwaltsgeb\374hren \t" + KostenRisiko.dbl2str(d)
				 + "\nAuslagenpauschale";
			if (dNumAnw == 2D) {
				s = s + "n";
			}		
			s = s + " \t" + KostenRisiko.dbl2str(dPausch) 
				+ "\nMWSt 19%         \t"
				 + KostenRisiko.dbl2str(dMwst) + "\n";
		}
		s = s + "Gerichtsgeb\374hren \t" + KostenRisiko.dbl2str(dGergeb) + "\n";
		
		if (dAusl > 0.0) {
			s = s + "Zeugen u Sachverst.\t" + KostenRisiko.dbl2str(dAusl) + "\n";
		}

		    s = s + "                \t---------------\nGesamtkosten     \t"
			 + KostenRisiko.dbl2str(dGestamtkosten) + "\n" ;
		tTEXT.setText(s);                 // Ergebnistext ausgeben
	}

	/**
	 *  Informationen zum Applet
	 *
	 *@return    Informationsstring
	 */
	public java.lang.String getAppletInfo() {
		return "KostenRisiko Version 3.3: \n - \251 1998-2007 Franz Xaver Dimbeck, Erding \n - Freeware-Lizenz: GNU GPL";
	};

    public String[][] getParameterInfo() {
        
        String pinfo[][] = {
         {"Farbe",    "RRGGBB",    "Farbe des Hintergrunds in Hex"}
         
         };
        return pinfo;
        };

    
	/**
	 *  string (mit DezimalKomma) in Zahl umwandeln, auf zwei
	 *  Nachkomastellen kaufmnnisch gerundet
	 *
	 *@param  s  der umzuwandelnde String
	 *@return    das Ergebnis, wenn der String nicht in eine Zahl
	 *      umgewandelt werden konnt, w1rd 0.00 zurckgegeben
	 */
	public static double str2dbl(java.lang.String s) {
    java.lang.String s2;
	double  d;
		try {
		    s2=s.replaceAll("\\.","");
		    s2=s2.replaceAll(" ","");
			d = java.lang.Double.valueOf(s2.replace(',', '.')).doubleValue();
			d = KostenRisiko.runde(d);
		} catch (java.lang.NumberFormatException numberformatexception) {
			d = 0.0D;
		}
		return d;
	}

	/**
	 *  Verwandelt Zahl in String mit Dezimalkomma und
	 *  Tausendertrennzeichen, kaufmnnisch gerundet auf zwei
	 *  Nachkommastellen, mit Euro-Zeichen am Ende
	 *
	 *@param  d  Zahl, die umgewandelt werden soll
	 *@return    String mit der formatierten Zahl
	 */
	public static java.lang.String dbl2str(double d) {

	long              l   = (long) java.lang.Math.floor(java.lang.Math.abs(d));
	long              l1  = (long) java.lang.Math.round(
			(java.lang.Math.abs(d) - (double) l) * 100D);
	java.lang.String  s   = java.lang.String.valueOf(l);
	java.lang.String  s1  = java.lang.String.valueOf(l1);
	java.lang.String  s2  = "";
	java.lang.String  s3  = "";
		if (s1.length() < 2) {
			s1 = "0" + s1;
		}

	int               i   = s.length() - 3;
		if (d < 0.0D) {
			s2 = "-";
		}
		if ((l >= 1000L) || (l <= -1000L)) {
			for (; i >= 1; i -= 3) {
				s = s.substring(0, i) + "." + s.substring(i, s.length());
			}
		}
		s3 = s2 + s + "," + s1 + " \u20ac";   //String zusammensetzen, EURO-Zeichen ans Ende
		for (int j = s3.length() - 2; j < 14; ) {
			j = s3.length();
			s3 = " " + s3;
		}
		return s3;
	}

	/**
	 *  rundet kaufmnnisch auf zwei Nachkommastellen
	 *
	 *@param  d  zu rundende Zahl
	 *@return    gerundete Zahl
	 */
	private static double runde(double d) {
		return java.lang.Math.round(d * 100D) / 100D;
	}

	/**
	 *  getDouble(TextFiel) wandelt den Inhalt eines Textfeldes in eine
	 *  Zahl um
	 *
	 *@param  textfield  Textfeld, dessen Ihnhalt ungewandelt werden
	 *      soll>
	 *@return            Zahlenwert (double) des Textfeldinhaltes >
	 */
	private static double getDouble(java.awt.TextField textfield) {
		return str2dbl(textfield.getText());
	}

	/**
	 *  teilgeb: Hilfsfunktion, berechnet die Teilgebhr aus einer
	 *  Gebhrenstufe
	 *
	 *@param  Strw      Streitwert
	 *@param  Untergr   Untergrenze
	 *@param  Obergr    Obergrenze
	 *@param  Schrittw  Schrittweite der Stufen
	 *@param  Erhoeh    Erhhungsbetrag pro Stufe
	 *@return           Teilgebhr
	 */
	private static double teilgeb(double Strw, double Untergr, double Obergr, double Schrittw,
	                              double Erhoeh) {
	double  AnzStufen;
		if (Strw > Obergr) {
			Strw = Obergr;
		}
		Strw -= Untergr;
		if (Strw <= 0.0D) {
			return 0.0D;
		}
		AnzStufen = java.lang.Math.ceil(Strw / Schrittw);
		if ((AnzStufen * Schrittw) > Obergr) {
			AnzStufen--;
		}
		return AnzStufen * Erhoeh;
	}

	/**
	 *  berechnet die Anwaltsgebhr
	 *
	 *@param  Streitw  Streitwert
	 *@param  zehntel  Zehntel (= Faktor * 10)
	 *@return          Gebhr nach RVG
	 */
	public static double GebRVG(double Streitw, double zehntel) {

	double  RAGeb  = 25D;
                                        //== Mindestgebhr
		RAGeb += teilgeb(Streitw, 300D, 1500D, 300D, 20D);
		RAGeb += teilgeb(Streitw, 1500D, 5000D, 500D, 28D);
		RAGeb += teilgeb(Streitw, 5000D, 10000D, 1000D, 37D);
		RAGeb += teilgeb(Streitw, 10000D, 25000D, 3000D, 40D);
		RAGeb += teilgeb(Streitw, 25000D, 50000D, 5000D, 72D);
		RAGeb += teilgeb(Streitw, 50000D, 200000D, 15000D, 77D);
		RAGeb += teilgeb(Streitw, 200000D, 500000D, 30000D, 118D);
		RAGeb += teilgeb(Streitw, 500000D, 1E+020D, 50000D, 150D);
		RAGeb = (zehntel * RAGeb) / 10D;
		if (RAGeb < 10D) {
			RAGeb = 10D;
		}
		RAGeb = runde(RAGeb);
		return RAGeb;
	}





	/**
	 *  Berechnet die Gerichtsgebhr
	 *
	 *@param  Streitw  Streitwert
	 *@param  zehntel  Zehntel
	 *@return          GKG-Gebhr
	 */
	public static double GebGkgE(double Streitw, double zehntel) {

	double  GerGeb  = 25D;
                                        //== Mindestgebhr
		GerGeb += teilgeb(Streitw, 300D, 1500D, 300D, 10D);
		GerGeb += teilgeb(Streitw, 1500D, 5000D, 500D, 8D);
		GerGeb += teilgeb(Streitw, 5000D, 10000D, 1000D, 15D);
		GerGeb += teilgeb(Streitw, 10000D, 25000D, 3000D, 23D);
		GerGeb += teilgeb(Streitw, 25000D, 50000D, 5000D, 29D);
		GerGeb += teilgeb(Streitw, 50000D, 200000D, 15000D, 100D);
		GerGeb += teilgeb(Streitw, 200000D, 500000D, 30000D, 150D);
		GerGeb += teilgeb(Streitw, 500000D, 1E+020D, 50000D, 150D);
		GerGeb = (zehntel * GerGeb) / 10D;
		if (GerGeb < 10D) {
			GerGeb = 10D;
		}
		GerGeb = runde(GerGeb);
		return GerGeb;
	}
}
